---
title: Dominators
slug: Tools/Memory/Dominators
---
<div>{{ToolsSidebar}}</div><div class="summary" id="Concepts">
<p>This article provides an introduction to the concepts of <em>Reachability</em>, <em>Shallow</em> versus <em>Retained</em> size, and <em>Dominators</em>, as they apply in garbage-collected languages like JavaScript.</p>

<p>These concepts matter in memory analysis, because often an object may itself be small, but may hold references to other much larger objects, and by doing this will prevent the garbage collector from freeing that extra memory.</p>

<p>You can see the dominators in a page using the <a href="/en-US/docs/Tools/Memory/Dominators_view">Dominators view</a> in the Memory tool.</p>
</div>

<p>With a garbage-collected language, like JavaScript, the programmer doesn't generally have to worry about deallocating memory. They can just create and use objects, and when the objects are no longer needed, the runtime takes care of cleaning up, and frees the memory the objects occupied.</p>

<h2 id="Reachability">Reachability</h2>

<p>In modern JavaScript implementations, the runtime decides whether an object is no longer needed based on <em>reachability</em>. In this system the heap is represented as one or more graphs. Each node in the graph represents an object, and each connection between nodes (edge) represents a reference from one object to another. The graph starts at a root node, indicated in these diagrams with "R".</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/12383/memory-graph.svg" style="display: block; height: 268px; margin-left: auto; margin-right: auto; width: 384px;"></p>

<p>During garbage collection, the runtime traverses the graph, starting at the root, and marks every object it finds. Any objects it doesn't find are unreachable, and can be deallocated.</p>

<p>So when an object becomes unreachable (for example, because it is only referenced by a single local variable which goes out of scope) then any objects it references also become unreachable, as long as no other objects reference them:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/12375/memory-graph-unreachable.svg" style="display: block; height: 267px; margin-left: auto; margin-right: auto; width: 383px;"></p>

<p>Conversely, this means that objects are kept alive as long as some other reachable object is holding a reference to them.</p>

<h2 id="Shallow_and_retained_size">Shallow and retained size</h2>

<p>This gives rise to a distinction between two ways to look at the size of an object:</p>

<ul>
 <li><em>shallow size</em>: the size of the object itself</li>
 <li><em>retained size</em>: the size of the object itself, plus the size of other objects that are kept alive by this object</li>
</ul>

<p>Often, objects will have a small shallow size but a much larger retained size, through the references they contain to other objects. Retained size is an important concept in analyzing memory usage, because it answers the question "if this object ceases to exist, what's the total amount of memory freed?".</p>

<h2 id="Dominators">Dominators</h2>

<p>A related concept is that of the <em>dominator</em>. Node B is said to dominate node A if every path from the root to A passes through B:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/12379/memory-graph-dominators.svg" style="display: block; height: 309px; margin-left: auto; margin-right: auto; width: 471px;"></p>

<p>If any of node A's dominators are freed, then node A itself becomes eligible for garbage collection.</p>

<p><a id="immediate_dominator">If node B dominates node A, but does not dominate any of A's other dominators, then B is the <em>immediate dominator</em> of A:</a></p>

<p><img alt="" src="https://mdn.mozillademos.org/files/12381/memory-graph-immediate-dominator.svg" style="display: block; height: 309px; margin-left: auto; margin-right: auto; width: 467px;"></p>

<p><a id="multiple-paths">One slight subtlety here is that if an object A is referenced by two other objects B and C, then neither object is its dominator</a>, because you could remove either B or C from the graph, and A would still be retained by its other referrer. Instead, the immediate dominator of A would be its first common ancestor:<br>
 <img alt="" src="https://mdn.mozillademos.org/files/12331/memory-graph-dominator-multiple-references.svg" style="display: block; height: 283px; margin-left: auto; margin-right: auto; width: 211px;"></p>

<h2 id="See_Also">See Also</h2>

<p><a href="https://en.wikipedia.org/wiki/Dominator_%28graph_theory%29">Dominators in graph theory</a>.</p>

<p><a href="https://en.wikipedia.org/wiki/Tracing_garbage_collection">Tracing garbage collection</a>.</p>
